//AV 19.11.99 䥩  colorer regexp
#include <assert.h>

#define FLAG_UP_CASE     1
#define FLAG_DOWN_CASE   2
#define FLAG_UP_NEXT     4
#define FLAG_DOWN_NEXT   8

//**************************************************************************
// ।   ⥬ 㣨 Colorer
//   ४⭮ 뤥 梥⮬ ⥪  䮭
//**************************************************************************
static int ConnectToColorerDLL( void ){

  //   3.0 ⥫쭮 - "Working", ᫥ "working"
  int Working;
  if( GetRegKey(HKEY_CURRENT_USER,"","working",Working,false,ColorerPluginRootKey) == false 
       &&
      GetRegKey(HKEY_CURRENT_USER,"","Working",Working,false,ColorerPluginRootKey) == false )//祭   Colorer
     return 1;// 


  if( Working == true ) return -1; //Colorer 몫祭
  else                  return 0;
}

//**************************************************************************
//    ப  
//**************************************************************************
static int add(int *len, char **s, const char *a, int alen, int &flag) {
    int NewLen = *len + alen;
    int i;

    NewLen = NewLen * 2;

    if (alen == 0)
        return 0;

    if (*s) {
        *s = (char *) realloc( *s, NewLen );
        assert(*s);
        memcpy(*s + *len, a, alen);
    } else {
        *s = (char *) malloc( NewLen);
        assert(*s);
        memcpy(*s, a, alen);
        *len = 0;
    }
    if (flag & FLAG_UP_CASE) {
        char *p = *s + *len;

        for (i = 0; i < alen; i++) {
            *p = (char)toupcOEM( *p );
            p++;
        }
    } else if (flag & FLAG_DOWN_CASE) {
        char *p = *s + *len;

        for (i = 0; i < alen; i++) {
            *p = (char)toDowncOEM( *p );
            p++;
        }
    }
    if (flag & FLAG_UP_NEXT) {
        char *p = *s + *len;

        *p = (char)toupcOEM( *p );
        flag &= ~FLAG_UP_NEXT;
    } else if (flag & FLAG_DOWN_NEXT) {
        char *p = *s + *len;

        *p = (char)toDowncOEM(*p);
        flag &= ~FLAG_DOWN_NEXT;
    }
    *len += alen;
    return 0;
}

//***************************************************************************
//   㭪 믮 Replace  ᭮ ࠧ  regexp
//***************************************************************************
int RxReplace(const char *rep, const char *Src, int /*len*/, SMatches *match, char **Dest, int *Dlen, char *ExpandStr ) {
    int dlen = 0;
    char *dest = 0;
    char Ch;
    int n;
    int flag = 0;

    *Dest = 0;
    *Dlen = 0;
    //    add(&dlen, &dest, Src, match->Open[0]);
    while (*rep) {
        switch (Ch = *rep++) {
            //        case '&':
            //            add(&dlen, &dest, Src + match->Open[0], match->Close[0] - match->Open[0], flag);
            //            break;
        case '\\':
            switch (Ch = *rep++) {
            case '0':
            case '1': case '2': case '3':
            case '4': case '5': case '6':
            case '7': case '8': case '9':
                n = Ch - 48;
                if (match->s[n] != -1 && match->e[n] != -1) {
                    add(&dlen, &dest, Src + match->s[n], match->e[n] - match->s[n], flag);
                } else return -1;
                break;
            case 0:
                if (dest)
                   free( dest);
                return -1; // error
            case 'r': Ch = '\r'; add(&dlen, &dest, &Ch, 1, flag); break;
            case 'n': Ch = '\n'; add(&dlen, &dest, &Ch, 1, flag); break;

            //AV 15.11.99
            //case 'b': Ch = '\b'; add(&dlen, &dest, &Ch, 1, flag); break;
            //case 'a': Ch = '\a'; add(&dlen, &dest, &Ch, 1, flag); break;

            case 't': {
               if( !(*ExpandStr) ){
                  Ch = '\t'; add(&dlen, &dest, &Ch, 1, flag);
               }
               else//AV 15.12.99 塞 \t  ஡ ( ன । Far)
                  add(&dlen, &dest, ExpandStr, strlen(ExpandStr), flag);      

            }break;

            case 'U': flag |= FLAG_UP_CASE; break;
            case 'u': flag |= FLAG_UP_NEXT; break;
            case 'L': flag |= FLAG_DOWN_CASE; break;
            case 'l': flag |= FLAG_DOWN_NEXT; break;
            case 'E':
            case 'e': flag &= ~(FLAG_UP_CASE | FLAG_DOWN_CASE); break;
/*            case 'x':
                {
                    int N;
                    int A;

                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 9) N = N + 48 - 65 + 10; if (N > 15) return 0;
                    rep++;
                    A = N << 4;
                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 9) N = N + 48 - 65 + 10; if (N > 15) return 0;
                    rep++;
                    A = A + N;
                    Ch = (char)A;
                }
                add(&dlen, &dest, &Ch, 1, flag);
                break;
            case 'd':
                {
                    int N;
                    int A;

                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 9) return 0;
                    rep++;
                    A = N * 100;
                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 9) return 0;
                    rep++;
                    A = N * 10;
                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 9) return 0;
                    rep++;
                    A = A + N;
                    Ch = (char)A;
                }
                add(&dlen, &dest, &Ch, 1, flag);
                break;
            case 'o':
                {
                    int N;
                    int A;

                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 7) return 0;
                    rep++;
                    A = N * 64;
                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 7) return 0;
                    rep++;
                    A = N * 8;
                    if (*rep == 0) return 0;
                    N = toupc(*rep) - 48; if (N > 7) return 0;
                    rep++;
                    A = A + N;
                    Ch = (char)A;
                }
                add(&dlen, &dest, &Ch, 1, flag);
                break;*/
            default:
                add(&dlen, &dest, &Ch, 1, flag);
                break;
            }
            break;
        default:
            add(&dlen, &dest, &Ch, 1, flag);
            break;
        }
    }
    //    add(&dlen, &dest, Src + match->Close[0], len - match->Close[0]);
    *Dlen = dlen;
    *Dest = dest;
    return 0;
}

//
static int  NumAddSymb = 0;//AV 25.11.99 - 㦥 ᨬ   ப-
static char SearchStrTmp[LenSearchStr], SearchStrTmpEnd[LenSearchStr];

static int  AddEndStr =  0;
static char ExpandStr[LenExpandStr];

static char SetRXStr_add[LenSearchStr];
static char SetRXStr_Buff[LenSearchStr];

//㭪 ஢ ப  祭 । ப
// ⮬  ஢ ⢨⥫쭮    ॣ᪯,    ᨬ
static bool CheckStrIn( char *Str, char *Check, bool Op ){
   char *BegStr = Str;
   while( Str++ ){
      Str = strstr( Str, Check );
      if( Str ){
         if( Op == true && BegStr != Str && *(--Str) == '\\' )
            continue;
         else
           return true;
      }
   }
   return false;
}

//******************************************************************
//  㭪 ४ ப ᪠  ᨬ  ॣᯮ
//******************************************************************
static void SetRegExpSearchStrTmp( ExtSearchReg *esr, char *SearchStr, struct EditorInfo *ei, int ProcBegStr ){


         AddEndStr = 0;
         NumAddSymb = 0;
         *SearchStrTmp = '\0';
         *SearchStrTmpEnd = '\0';
         strcpy( SearchStrTmp, "/" ); NumAddSymb++;
         strcat( SearchStrTmp, SearchStr );
         strcat( SearchStrTmp, "/" ); NumAddSymb++;
     
         if( esr->CaseSensitive == false ){
            strcat( SearchStrTmp, "i" );
            NumAddSymb++;
         }      
     
            *SetRXStr_Buff = '\0';
         
            //AV 07.12.99    ப  \r\n (᫨ 饬   ᫥ ப 䠩)      
            strcpy( SetRXStr_Buff, SearchStrTmp );//⮡   SearchStrTmp
            char *pos = SetRXStr_Buff;
         
            pos--;
            while( (pos = strchr( ++pos, '$' )) != NULL ){
               //᫨ $ -  ᨬ, 塞  \r\n
               if( !ThisSymbol( SetRXStr_Buff, pos ) ){
                  *SetRXStr_add  = '\0';
                  strcpy( SetRXStr_add, pos+1 );//࠭ ᮪ ப ᫥ $
   
                  if( !esr->SearchInFile )
                     strcpy( pos, "\r\n" );// "$"  "\r\n"
                  else
                     strcpy( pos, "\n" );// "$"  "\n" 
   
                  strcpy( SearchStrTmpEnd, SetRXStr_Buff );//
                  strcat( SearchStrTmpEnd, SetRXStr_add );// ࠭ ᮪
                  //ConvertToOEM( esr, SearchStrTmpEnd, LenSearchStr );
                  //ConvertToWinRus( SearchStrTmpEnd );
                  AddEndStr = 1;
               }
            }
   
   
         ConvertToOEM( esr, SearchStrTmp, LenSearchStr );
         //ConvertToWinRus( SearchStrTmp );
      
         //ࠦ ^+ - ४⭮
         if( CheckStrIn( SearchStrTmp, "^+", false ) == true ){
            esr->ErrRegExpSearch = 1;
            return;
         }
      
         // 砥 ᪠  䠩 ࠡ⠥  砫 ப ^
         if( esr->SearchInFile && ProcBegStr == 1 && *(SearchStrTmp+1) == '^' ){
           char beg[LenSearchStr] = "/\\n\\m";
           strcpy( SearchStrTmp, strcat( beg, SearchStrTmp + 2 ) );
           esr->ChangeBegStr = 1;
         }

         //୥   ^
         if( ProcBegStr == 2 && esr->ChangeBegStr == 1 && !memcmp( SearchStrTmp, "/\\n\\m", 3 ) ){
           char beg[LenSearchStr] = "/^";
           strcpy( SearchStrTmp, strcat( beg, SearchStrTmp + 3 ) );
           esr->ChangeBegStr = 0;
         }
    
         //AV 16.12.99
         if( esr->retest->SetExpr( SearchStrTmp) == false || (*SearchStrTmpEnd && esr->retest_end->SetExpr( SearchStrTmpEnd) == false ) ){
            esr->ErrRegExpSearch = 1;
            return;
         }
      
        if( !esr->SearchInFile ){
           if( ei->Options&EOPT_EXPANDTABS ){
              if( ei->TabSize >= 0 && ei->TabSize < LenExpandStr ){
                 memset( ExpandStr, ' ', ei->TabSize );
                 *(ExpandStr + ei->TabSize) = '\0';
              }
              else
                 *ExpandStr = '\0';
           }
           else
             *ExpandStr = '\0';
        }
        else *ExpandStr = '\0';
}

//*******************************************************************************************
//  㭪 믮 ࠧ, /  ப ᪠    ॣᯠ 
//*******************************************************************************************

static char *StrStrRegExp( char *Str, char *Sol, char *Eol, char *SearchStr, int *LenStr, ExtSearchReg *esr, int isEOF )
{
   SMatches match;

   int  LenRplStr;
   char *FindStr = Str; //⮡  NULL

   PRegExp p_retest;   

   //!!!!!!!!!!!!!!!!!!!!!!!
   //  SearchStrTmp 
   //  SearchStrTmpEnd
   //   ।⥫ 맮 SetRegExpSearchStr()
   char *SearchStrTmpPtr = !AddEndStr ? SearchStrTmp : isEOF ? SearchStrTmp : *SearchStrTmpEnd ? SearchStrTmpEnd : SearchStrTmp;

   p_retest = !AddEndStr ? esr->retest : isEOF ? esr->retest : *SearchStrTmpEnd ? esr->retest_end : esr->retest;

   //!!!!!!!!!!!!!!!!!!!!!!!

   if( FindStr ){

      //ConvertToOEM( Sol );
      if( p_retest->Parse( /*line*/Str, Sol, Eol, &match, NULL, -1 ) && match.s[0] >= 0 && match.e[0] >= 0 ){
   
          int CurLenSrchStr = strlen(SearchStrTmpPtr);
   
          FindStr = Sol+match.s[0];
          if( *LenStr ) *LenStr = match.e[0] - match.s[0];//ॠ쭠   ப
  
          //. ஢ઠ  砥 ᫨ ப ᪠ 稭  ᨬ \B
          if( CurLenSrchStr - NumAddSymb >= 2 &&  *SearchStr == '\\' && *(SearchStr+1) == 'B' )// ᫮
             if( !*FindStr ) FindStr = NULL;//
   
          //. ஢ઠ  砥 ᫨ ப ᪠ 稭  ᨬ \b
          if( CurLenSrchStr - NumAddSymb >= 2 && *SearchStr == '\\' && *(SearchStr+1) == 'b' )//砫 ᫮
             if( !*FindStr ) FindStr = NULL;//
   
      }else
         FindStr = NULL;
 
      // ࠧ ப-  ॣᯠ
      if( esr->Replace && FindStr ){
         char *ReplaceStrTmp = NULL;

         //if( !esr->StrStrRX_ConvertReplace )
         //   esr->StrStrRX_ConvertReplace = (char*)HeapAlloc( esr->Heap, 0, strlen(esr->RXConvertReplace)+1 );
           
         //strcpy( esr->RX_ConvertReplace, esr->ConvertReplace/*esr->RXConvertReplace*/ );
 
         if( !RxReplace( esr->ReplaceStr, Sol, 0, &match, &ReplaceStrTmp, &LenRplStr, ExpandStr ) ){
            if( ReplaceStrTmp ){  
               *(ReplaceStrTmp + LenRplStr) = '\0';
               ConvertFromOEM( esr, ReplaceStrTmp, LenRplStr );
               if( LenRplStr >= strlen(esr->RXConvertReplace) )
                  esr->RXConvertReplace = (char*)realloc( esr->RXConvertReplace, LenRplStr + 1 );
               strcpy( esr->RXConvertReplace, ReplaceStrTmp );
               //AV 07.07.00
               if( esr->SearchInFile ) esr->LenStrReplace = LenRplStr;
            }
            else{ //ப  ॢ⨫   ப
               if( !esr->RXConvertReplace ) esr->RXConvertReplace = (char*)malloc( 1 );
               *(esr->RXConvertReplace) = '\0';
            }    
         }
         else esr->ErrRegExpReplace = 1;
   
         if( esr->ErrRegExpReplace ) FindStr = NULL;
   
         if( ReplaceStrTmp )           free( ReplaceStrTmp );
      }
  }

  return FindStr;

}
